"use strict";

angmoba.factory("AmobaGame", ["Game", function(Game) {

	var AmobaBoard = function(gamer, CellClass) {
		
		this.super.constructor.call(this,gamer,CellClass);
	}
	AmobaBoard.inherit(Game.Board);
	
	
	AmobaBoard.prototype.wonCell = function(r,c) {
		if (!this.inBoard(r,c) || this.rows[r][c].gamer != this.lastStepCell.gamer)
			return false;
		this.winCells.push(this.rows[r][c]);
		return true;	
	}
	
	AmobaBoard.prototype.won = function(lastStep) {
		if (!(lastStep = (lastStep || this.lastStepCell)))
			return false;
		this.lastStepCell = lastStep;

		var rows = this.rows.length, cols = this.rows[0].length;
		var x0 = lastStep.c, y0 = lastStep.r;
		var x1 = Math.max(0, x0-4), x2 = Math.min(cols-1, x0);
		var y1 = Math.max(0, y0-4), y2 = Math.min(rows-1, y0);
		
		var lastMover = this.lastStepCell.gamer;
		var count = 0, i, j, y00, r0, c0;

				
		//check horz
		//for(i=x1; i<=x0; ++i) {
		r0 = this.lastStepCell.r;
		c0 = this.lastStepCell.c - 4;
		for(i=0; i<5; ++i) {
			this.winCells = [];
			for(j=0; j<5; ++j)
				this.wonCell(r0, c0 + i + j);

			if (this.winCells.length == 5) {
				this.winner = lastMover;
				break;
			}
		}

		
		//check vert
		r0 = this.lastStepCell.r - 4;
		c0 = this.lastStepCell.c;
		if (!this.winner)
		for(i=0; i<5; ++i) {
			this.winCells = [];
			for(j=0; j<5; ++j)
				this.wonCell(r0 + i + j, c0);
			
			if (this.winCells.length == 5) {
				this.winner = lastMover;
				break;
			}
		}

		
		//check diag
		//y00 = y0 - 4;
		r0 = this.lastStepCell.r - 4;
		c0 = this.lastStepCell.c - 4;
		if (!this.winner)
		for(i=0; i<5; ++i) {
			this.winCells = [];
			for(j=0; j<5; ++j)
				this.wonCell(r0 + i + j, c0 + i + j);

			if (this.winCells.length == 5) {
				this.winner = lastMover;
				break;
			}
		}

		//check diag2
		//y00 = y0 + 4;
		r0 = this.lastStepCell.r + 4;
		c0 = this.lastStepCell.c - 4;
		if (!this.winner)
		for(i=0; i<5; ++i) {
			this.winCells = [];
			for(j=0; j<5; ++j)
				this.wonCell(r0 - i - j, c0 + i + j);

			if (this.winCells.length == 5) {
				this.winner = lastMover;
				break;
			}
		}
		
		if (this.winner) {
			for(var i in this.winCells)
				this.winCells[i].winPos = true;
		}
		
		return this.winner;
	}


	var AmobaCell = function(r, c) {
		this.super.constructor.call(this,r,c);
	}
	AmobaCell.inherit(Game.Cell);


	return $.extend({}, Game, {
		createBoard : function(gamer) {
			return new AmobaBoard(gamer, AmobaCell);
		}
	});

}]);
