"use strict";

angmoba.factory("Game", ["Config", function(Config) {

	//Base classes
	var Cell = function(r,c) {
		this.r = r;
		this.c = c;		
		this.gamer = "";//sign of the gamer
		this.last = false;//boolean, indicator of last step
		this.winPos = false;//boolean - winning position or not
	}
	Cell.prototype.cssClass = function() {
		return "cell " + this.gamer + (this.last ? " last" : "") + (this.winPos ? " won" : "");
	}
	Cell.prototype.click = function(gamer) {
		if (this.gamer)
			return;
		this.gamer = gamer;
	}
	
	Cell.prototype.toJson = function() {
		return JSON.stringify({
			r:this.r,
			c:this.c,
			gamer:this.gamer
		});
	}





	var Board = function(gamer, CellClass) {
		this.gamer = gamer;
		this.CellClass = CellClass;

		this.rows = new Array(Config.board.rows);

		for(var r=0; r<Config.board.rows; r++) {
			this.rows[r] = new Array(Config.board.cols);
			for(var c=0; c<Config.board.cols; c++) {
				this.rows[r][c] = new CellClass(r,c);
			}
		}

		this.lastStepCell = undefined;
		this.winner = undefined;
	}

	Board.prototype.step = function(gamer, _r, _c) {
		for(var r=0; r<this.rows.length; r++) {
			var row = this.rows[r];
			for(var c=0; c<this.rows[r].length; c++) {
				var cell = this.rows[r][c];
				if (_r==r && _c==c) {
					cell.gamer = gamer;
					cell.last = true;
					this.lastStepCell = cell;
				} else {
					cell.last = false;					
				}
			}
		}
		
		return this.won();
	}

	Board.prototype.won = function(lastStep) {
		return false;
	}
	
	Board.prototype.inBoard = function(r,c) {
		return r>=0 && c>=0 && r<this.rows.length && c<this.rows[0].length;
	}
	
	
	return {
		Board : Board,
		Cell : Cell
	};

}]);
