/**
 * example:

Person = function(name) {
	this.name = name;
}
Person.prototype.hi = function() {
	alert("hi i'm " + this.name);
}
Person.hi = function(){
	alert("Person::hi() called");	
};

Ninja = function(name, level) {
	this.super.constructor.call(this, name);
	this.level = level;
}
Ninja.inherit(Person);

Ninja.prototype.hi = function() {
	this.super.hi.call(this);
	alert("i'm on level " + this.level + " and i'll kill you now.");
}
Ninja.hi = function(){
	this.super.hi();
	alert("Ninja::hi() called");	
};

var p = new Person("Bill");
var n = new Ninja("Osaka", 3);
p.hi();
n.hi();
Person.hi();
Ninja.hi();

**/

Function.prototype.inherit = function(parentFunc) {
	var proto = parentFunc.prototype;
	if (!proto) {
		console.error("Function.prototype.inherit: parentFunc " + parentFunc + " must have prototype");
		return false;
	}

	for(var m in proto)
		if (this.prototype[m] === undefined)
			this.prototype[m] = proto[m];

	for(var m in parentFunc)
		if (this[m] === undefined)
			this[m] = parentFunc[m];

	this.prototype.super = proto;
	this.super = parentFunc;
	
	return true;
};
